::#############################################################################
::## SMILEHOUSE WORKSPACE INSTALLER LAUNCHER SCRIPT   (C) SMILEHOUSE OY 2006 ##
::#############################################################################

@echo off
setlocal enabledelayedexpansion

echo ##############################################################################
echo #                 Welcome to Smilehouse Workspace installer!                  #
echo ##############################################################################
echo.
echo Installer shall check a few basic settings before continuing
echo.

set PARAM=%1

if not exist ..\..\bin\workspace_installer.jar goto installererror

set PATH=%PATH%;%SYSTEMROOT%;%SYSTEMROOT%\system32

call :startup reg.exe regedit.exe
endlocal
goto :EOF

:startup
set MY_JAVA_HOME=
set MY_CATALINA_HOME=
set MY_CLASSPATH=

set COPYREGKEYFUNCTION=CopyRegKeyToVariable
set REGCOMMAND=%~$PATH:1
if not ["%REGCOMMAND%"]==[""] goto tryautodetect
set REGCOMMAND=%1
if exist %REGCOMMAND% goto tryautodetect

set COPYREGKEYFUNCTION=CopyRegKeyToVariable2
set REGEDITCOMMAND=%~$PATH:2
if not ["%REGEDITCOMMAND%"]==[""] goto tryautodetect
set REGEDITCOMMAND=%2
if not exist %REGEDITCOMMAND% goto skipautodetect

:tryautodetect
set MY_JAVA_HOME=%JAVA_HOME%
if ["%MY_JAVA_HOME%"]==[""] call :%COPYREGKEYFUNCTION% "HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Development Kit" JavaHome MY_JAVA_HOME
if ["%MY_JAVA_HOME%"]==[""] call :%COPYREGKEYFUNCTION% "HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Runtime Environment" JavaHome MY_JAVA_HOME

set MY_CATALINA_HOME=%CATALINA_HOME%
if ["%MY_CATALINA_HOME%"]==[""] call :%COPYREGKEYFUNCTION% "HKEY_LOCAL_MACHINE\SOFTWARE\Apache Software Foundation\Tomcat" InstallPath MY_CATALINA_HOME

:skipautodetect
if ["%MY_JAVA_HOME%"]==[""] goto javaerror
if not exist "%MY_JAVA_HOME%\bin\java.exe" goto javaerror

if ["%MY_CATALINA_HOME%"]==[""] goto catalinaerror

call :start "%MY_CATALINA_HOME%"
goto :EOF

:start
set MY_SHORT_CATALINA_HOME=%~sf1

set MY_CLASSPATH=%CLASSPATH%
if not ["%MY_CLASSPATH%"]==[""] goto classpathok

echo No CLASSPATH specified - collecting all JAR files from Tomcat's
echo library directories
for %%j in ("common\endorsed", "common\lib", "shared\lib") do for %%i in ( "%MY_CATALINA_HOME%\%%j\*.jar" ) do set MY_CLASSPATH=%%i;!MY_CLASSPATH!

echo.

:classpathok

echo You should have at least JDBC driver in your classpath.
echo CLASSPATH is as follows:
echo.
echo CLASSPATH=%MY_CLASSPATH%
echo.
echo Are you comfortable with this issue? [ENTER continues, CTRL-C aborts]
pause >NUL

set MY_CLASSPATH=..\..\bin\workspace_installer.jar;%MY_JAVA_HOME%\lib\rt.jar;%MY_JAVA_HOME%\lib\charsets.jar;%MY_JAVA_HOME%\jre\lib\rt.jar;%MY_JAVA_HOME%\jre\lib\charsets.jar;%MY_CLASSPATH%
"%MY_JAVA_HOME%\bin\java.exe" -cp "%MY_CLASSPATH%" -Dcatalina.home="%MY_SHORT_CATALINA_HOME%" smilehouse.workspace.installer2.Installer en 437 %PARAM%

pause
goto :EOF

:CopyRegKeyToVariable
if ["%REGCOMMAND%"]==[""] goto :EOF
for /F "tokens=3 delims=	" %%i in ('%REGCOMMAND% query %1 /s 2^>NUL ^| find "REG_" ^| find "%2"') do set %3=%%i
goto :EOF

:CopyRegKeyToVariable2
if ["%REGEDITCOMMAND%"]==[""] goto :EOF
set TEMPHOME=
set TEMPFILE=%TEMP%\wsi%RANDOM%.tmp
start /wait %REGEDITCOMMAND% /e "%TEMPFILE%" %1
if not exist %TEMPFILE% goto :CopyRegKeyToVariable2_cleanup
for /F "tokens=1,2 delims==" %%A in ('type "%TEMPFILE%"') do if ["%%~A"]==["%2"] set TEMPHOME=%%~B
del "%TEMPFILE%"
if not ["%TEMPHOME%"]==[""] call set %3=%TEMPHOME:\\=\%
set TEMPHOME=
:CopyRegKeyToVariable2_cleanup
set TEMPFILE=
goto :EOF

:installererror
echo workspace_installer.jar is missing!
goto error

:javaerror
echo Seems like JAVA_HOME environment variable is missing or invalid!
goto error

:catalinaerror
echo Seems like CATALINA_HOME environment variable is missing!
goto error

:error
echo.
echo Installation failed!
pause
goto :EOF
